package patrones.mediator.ej1;

import java.util.ArrayList;
import java.util.HashMap;

public class Mediator {
	private HashMap<String, Item> items;
	private HashMap<String, Category> categories;

	private ArrayList<ItemCatAssoc> assoc;

	public Mediator() {

		items = new HashMap<String, Item>();
		categories = new HashMap<String, Category>();

		assoc = new ArrayList<ItemCatAssoc>();
	}

	// No queda claro en que consiste el registro
	public void registerItem(Item i) {
		items.put(i.getDesc(), i);
	}

	public void registerCategory(Category c) {
		categories.put(c.getDesc(), c);
	}

	private boolean isItemRegistered(Item item) {
		return items.containsKey(item.getDesc());
	}

	private boolean isCategoryRegistered(Category cat) {
		return categories.containsKey(cat.getDesc());
	}

	private boolean find(Item item, Category cat) {
		for (int i = 0; i < assoc.size(); i++) {
			if (assoc.get(i).esIgual(item, cat))
				return true;
		}
		return false;
	}

	public void add(Item item, Category cat) {
		if (!isItemRegistered(item)){
			System.out.println("Item no esta registrado");
			return;
		}
		if (!isCategoryRegistered(cat)){
			System.out.println("Categoria no esta registrada");
			return;
		}
		if (!find(item, cat)) {
			assoc.add(new ItemCatAssoc(item, cat));
			System.out.println("Item '" + item.getDesc()
					+ "' has been added to the '" + cat.getDesc()
					+ "' Category ");
		}
	}

	public void delete( Item item, Category cat) {
		assoc.remove(new ItemCatAssoc(item, cat));
		System.out.println("Item '" + item.getDesc()
				+ "' has been deleted from the '" + cat.getDesc()
				+ "' Category ");
	}

}
